//---------------------------------------------------------------------------
// This animation is to draw a border on the selected element on focus event
//---------------------------------------------------------------------------

.draw-element-border {
  transition: color 0.25s;

  border: 0;
  box-sizing: border-box;

  // Using inset box-shadow instead of border for sizing simplicity
  box-shadow: inset 0 0 0 2px transparent;

  // Required, since we"re setting absolute on pseudo-elements
  position: relative;
  vertical-align: middle;

  &::before,
  &::after {
    box-sizing: inherit;
    content: '';
    position: absolute;
    width: 100%;
    height: 100%;
  }

  &::before,
  &::after {
    // Set border to invisible, so we don"t see a 4px border on a 0x0 element before the transition starts
    border: 2px solid transparent;
    width: 0;
    height: 0;
  }

  // This covers the top & right borders (expands right, then down)
  &::before {
    top: 0;
    left: 0;
  }

  // And this the bottom & left borders (expands left, then up)
  &::after {
    bottom: 0;
    right: 0;
  }

  // Focus styles
  &:focus::before,
  &:focus::after {
    width: 100%;
    height: 100%;
  }

  &:focus::before {
    border-top-color: var(--primary); // Make borders visible
    border-right-color: var(--primary);
    transition:
      width 0.25s ease-out, // Width expands first
      height 0.25s ease-out 0.25s; // And then height
  }

  &:focus::after {
    border-bottom-color: var(--primary); // Make borders visible
    border-left-color: var(--primary);
    transition:
      border-color 0s ease-out 0.5s, // Wait for ::before to finish before showing border
      width 0.25s ease-out 0.5s, // And then exanding width
      height 0.25s ease-out 0.75s; // And finally height
  }
}

//---------------------------------------------------------------------------
// This animation is to show an element with a fade in up transition
//---------------------------------------------------------------------------


@keyframes fade-in-up {
  from {
    transform: translate3d(0,40px,0)
  }

  to {
    transform: translate3d(0,0,0);
    opacity: 1
  }
}

@-webkit-keyframes fade-in-up {
  from {
    transform: translate3d(0,20px,0)
  }

  to {
    transform: translate3d(0,0,0);
    opacity: 1
  }
}

.animated {
  animation-duration: 700ms;
  animation-fill-mode: both;
  -webkit-animation-duration: 700ms;
  -webkit-animation-fill-mode: both
}

.animated-fade-in-up {
  opacity: 0
}

.fade-in-up {
  opacity: 0;
  animation-name: fade-in-up;
  -webkit-animation-name: fade-in-up;
}

//---------------------------------------------------------------------------
// This animation is to draw a border on a the parent div of a focused input
//---------------------------------------------------------------------------


.base-to-draw {
  transition: color 0.25s;

  border: 0;
  box-sizing: border-box;

  // Using inset box-shadow instead of border for sizing simplicity
  box-shadow: inset 0 0 0 2px transparent;

  // Required, since we"re setting absolute on pseudo-elements
  position: relative;
  vertical-align: middle;

  &::before,
  &::after {
    box-sizing: inherit;
    content: '';
    position: absolute;
    width: 100%;
    height: 100%;
  }

  &::before,
  &::after {
    // Set border to invisible, so we don"t see a 4px border on a 0x0 element before the transition starts
    border: 2px solid transparent;
    width: 0;
    height: 0;
  }

  // This covers the top & right borders (expands right, then down)
  &::before {
    top: 0;
    left: 0;
  }

  // And this the bottom & left borders (expands left, then up)
  &::after {
    bottom: 0;
    right: 0;
  }
}

.is-focused {
  // Focus styles
  &::before,
  &::after {
    width: 100%;
    height: 100%;
  }

  &::before {
    border-top-color: var(--primary); // Make borders visible
    border-right-color: var(--primary);
    transition:
      width 0.25s ease-out, // Width expands first
      height 0.25s ease-out 0.25s; // And then height
  }

  &::after {
    border-bottom-color: var(--primary); // Make borders visible
    border-left-color: var(--primary);
    transition:
      border-color 0s ease-out 0.5s, // Wait for ::before to finish before showing border
      width 0.25s ease-out 0.5s, // And then exanding width
      height 0.25s ease-out 0.75s; // And finally height
  }
}
